/* iOSでX68000の256色をすべて表示する / Display X68000's 256 colors
// 全機種対応 / Compatible for all device
// for V3.2 later

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)

enum
	DIVX=16:// 水平分割数 / the number of horizontal divide
endenum

int gwx,gwy
gwy=getScreenSize(gwx)
//print gwx,gwy

int wx=gwx/DIVX
//print wx
if wx>=32 then wx=32
int wy=wx:// 正方形 / Square
if wy*DIVX>gwy then {
	// 横はいいんだけど縦がはみ出てしまう / Horizontal is ok, but virtical is over the limit
	// その時は縦で補正
	wy=gwy/DIVX
	wx=wy
}
float fntsz=getFontSize(wx)
//print fntsz

int x=0,y=0
int c
for c=0 to 255
	gColor(x68256Color2iOSColor(c))
	fill(x,y,x+wx-1,y+wy-1)
	gColor(x68256Color2iOSColor(255-c)):// 補完色で文字を描画 / Draw with color complementary
	str vs="  "+str$(c)
	vs=right$(vs,3)
	symbol(x+4,y+8,vs,"TimesNewRoman",fntsz)
	x=x+wx
	if x>=wx*DIVX then {
		x=0
		y=y+wy
	}
next
end

func float getFontSize(wx;int)
	// 1マス32ドットの時16がちょうどよかったので比例配分 / calcurate font size
	float fwx=wx
	fwx=fwx/32
	return (16.0*fwx)
endfunc

end
