/* Oh!X 1993/2 p83 : 渦による画像の変形
/* オリジナルにあった0除算バグなどを、分かる範囲で修正
// V3.00以降専用

enum
	FNTSZ=16
//	WX=256
//	WY=256
//	SX=128
//	SY=128
	WX=512
	WY=512
	SX=0
	SY=0
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(64):// テキスト文字フォントサイズを算出させる

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE0):bitmapOpen(0,0,YES)
imgLoad(0,0,WX,WY,"IMG1.JPG"):/* ここに画像ファイル名を入れる
/*
float a,b,x,y
int i,j
dim int vx(WX-1,WY-1)
dim int vy(WX-1,WY-1)

/* 画像を取り込む
dim int aa(WX-1,WY-1)
for j=0 to WY-1
	for i=0 to WX-1
		aa(i,j)=bitmapPoint(SX+i,SY+j)
	next
next
hitKey(NO)
srand2()
/* 変形情報作成
for i=0 to 2
	locate(0,0):print using "###";i
	/* cx=cy=0だとゼロ除算が発生してしまうことがある
	int cx,cy
	repeat
		cx=randX68()/(WX/4)
		cy=randX68()/(WX/4)
	until cx<>cy
	voltex(cx,cy)
next
/* 表示
hitKey(NO)
wipe()
disp()
/* 終了
apage(GPAGE0):bitmapClose()
end
/*
func voltex(cx,cy)
int i,j,x,y://,k,l
float a,b,k,l
	locate(0,2):print "cx=";cx,"cy=";cy
	y=128
	for j=0 to WY-1
		locate(0,1):print j
		for i=0 to WX-1
			a=sqr((i-cx)*(i-cx)+(j-cy)*(j-cy))
			b=pi(3)/(a/5#+0.5#)
			if a=0 then {
				// 0除算対策
				k=0:l=0
			} else {
				k=(i-cx)*(1-1#/(a*a))
				l=(j-cy)*(1-1#/(a*a))
			}
			x=k*cos(b)-l*sin(b)
			y=l*cos(b)+k*sin(b)
			vx(i,j)=vx(i,j)+x+cx-i
			vy(i,j)=vx(i,j)+y+cy-j
		next
	next
endfunc
/*
func disp()
	for j=0 to WY-1
		for i=0 to WX-1
			x=vx(i,j)+i
			y=vy(i,j)+j
			if x<0    then x=0
			if x>WX-1 then x=WX-1
			if y<0    then y=0
			if y>WY-1 then y=WY-1
			gColor(aa(x,y))
			pset(i,j)
		next
	next
endfunc
