// circleテスト
// for V3.20 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop


int cx=50,cy=50,cwise
int r=15
float st,ed
int i,j
//
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
apage(GPAGE0):bitmapOpen(0,0,YES)
lineWidth(2)
enum
	FNTSZ=12
endenum
str FONT="Migu-1M-Regular"

if NO then {
	// clockテスト
	// (1)waitと比較
	int clk=clock()
	print "clock1=";clk
	print "wait 2 sec"
	wait(2)
	int clk2=clock()
	print "clock2=";clk2
	clk2=clk2-clk
	print "⊿clock=";clk2;"/second=";clk2/CLOCKS_PER_SEC,"実CLOCKS_PER_SEC=";(clk2/2.0)
	// (2)time$との比較
	int t,tt
	t=val(right$(time$,2))
	repeat:tt=val(right$(time$,2)):until t<>tt
	// 正確な秒を変わり目を知るため2回
	t=tt
	repeat:tt=val(right$(time$,2)):until t<>tt
	// テスト開始
	clk=clock()
	print "clock1=";clk
	t=tt
	print "time$=1sec"
	repeat:tt=val(right$(time$,2)):until t<>tt
	clk2=clock()
	print "clock2=";clk2
	clk2=clk2-clk
	print "⊿clock=";clk2;"/second=";clk2/CLOCKS_PER_SEC

	end
}

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
//
gColor(&hff0000ff)
cwise=0
st=0:ed=0
for i=0 to 360/45
	circle(cx,cy,r,st,ed,cwise)
	symbol(cx-FNTSZ/4,cy+r+5,str$(i),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	ed=ed+pi(1.0/4.0)
next
symbol(cx-FNTSZ/4,cy+r+5,"endAngle",FONT,FNTSZ)

gColor(&h00ff00ff)
cwise=1
cx=50:cy=cy+100
st=0:ed=0
for i=0 to 360/45
	circle(cx,cy,r,st,ed,cwise)
	symbol(cx-FNTSZ/4,cy+r+5,str$(i),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	ed=ed+pi(1.0/4.0)
next
symbol(cx-FNTSZ/4,cy+r+5,"endAngle",FONT,FNTSZ)
//
gColor(&hff8000ff)
cwise=0
cx=50:cy=cy+100
st=0:ed=0:j=0
for i=0 to 360/45
	circle(cx,cy,r,st,ed,cwise)
	symbol(cx-FNTSZ/4,cy+r+5 ,str$(j),FONT,FNTSZ)
	symbol(cx-FNTSZ/4,cy+r+18,str$(i),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	st=ed
	j=i
	ed=ed+pi(1.0/4.0)
next
symbol(cx-FNTSZ/4,cy+r+5 ,"startAngle",FONT,FNTSZ)
symbol(cx-FNTSZ/4,cy+r+18,"endAngle"  ,FONT,FNTSZ)

gColor(&h80ff00ff)
cwise=1
cx=50:cy=cy+100
st=0:ed=0:j=0
for i=0 to 360/45
	circle(cx,cy,r,st,ed,cwise)
	symbol(cx-FNTSZ/4,cy+r+5 ,str$(j),FONT,FNTSZ)
	symbol(cx-FNTSZ/4,cy+r+18,str$(i),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	st=ed
	j=i
	ed=ed+pi(1.0/4.0)
next
symbol(cx-FNTSZ/4,cy+r+5 ,"startAngle",FONT,FNTSZ)
symbol(cx-FNTSZ/4,cy+r+18,"endAngle"  ,FONT,FNTSZ)

// 楕円テスト
int hv=64
r=20
cx=50:cy=cy+100
for i=0 to 360/45
	bitmapEllipse(cx,cy,r,hv,&h00ff80ff)
	symbol(cx-FNTSZ/4,cy+r+5 ,str$(hv),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	hv=hv+64
next
bitmapImgLoad()
symbol(cx-FNTSZ/4,cy+r+5 ,"扁平率",FONT,FNTSZ)

// 楕円テスト
int aa=20,bb=8
cx=50:cy=cy+100
for i=0 to 360/45
	bitmapEllipse2(cx,cy,aa,bb,&h808080ff)
	symbol(cx-FNTSZ/4,cy+r+5 ,str$(aa),FONT,FNTSZ)
	symbol(cx-FNTSZ/4,cy+r+18,str$(bb),FONT,FNTSZ)
	cx=cx+50
	if cx>=700 then cx=0:cy=cy+50
	aa=aa-2
	bb=bb+2
next
bitmapImgLoad()
symbol(cx-FNTSZ/4,cy+r+5 ,"aa",FONT,FNTSZ)
symbol(cx-FNTSZ/4,cy+r+18,"bb",FONT,FNTSZ)
//
apage(GPAGE0):bitmapClose()
end
